xref: /titanic_51/usr/src/cmd/svc/milestone/net-physical (revision b509e89b2befbaa42939abad9da1d7f5a8c6aaae)
17c478bd9Sstevel@tonic-gate#!/sbin/sh
27c478bd9Sstevel@tonic-gate#
37c478bd9Sstevel@tonic-gate# CDDL HEADER START
47c478bd9Sstevel@tonic-gate#
57c478bd9Sstevel@tonic-gate# The contents of this file are subject to the terms of the
66927f468Sdp# Common Development and Distribution License (the "License").
76927f468Sdp# You may not use this file except in compliance with the License.
87c478bd9Sstevel@tonic-gate#
97c478bd9Sstevel@tonic-gate# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
107c478bd9Sstevel@tonic-gate# or http://www.opensolaris.org/os/licensing.
117c478bd9Sstevel@tonic-gate# See the License for the specific language governing permissions
127c478bd9Sstevel@tonic-gate# and limitations under the License.
137c478bd9Sstevel@tonic-gate#
147c478bd9Sstevel@tonic-gate# When distributing Covered Code, include this CDDL HEADER in each
157c478bd9Sstevel@tonic-gate# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
167c478bd9Sstevel@tonic-gate# If applicable, add the following below this CDDL HEADER, with the
177c478bd9Sstevel@tonic-gate# fields enclosed by brackets "[]" replaced with your own identifying
187c478bd9Sstevel@tonic-gate# information: Portions Copyright [yyyy] [name of copyright owner]
197c478bd9Sstevel@tonic-gate#
207c478bd9Sstevel@tonic-gate# CDDL HEADER END
217c478bd9Sstevel@tonic-gate#
227c478bd9Sstevel@tonic-gate#
23e11c3f44Smeem# Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
247c478bd9Sstevel@tonic-gate# Use is subject to license terms.
257c478bd9Sstevel@tonic-gate#
267c478bd9Sstevel@tonic-gate# Copyright (c) 1984, 1986, 1987, 1988, 1989 AT&T.
277c478bd9Sstevel@tonic-gate# All rights reserved.
287c478bd9Sstevel@tonic-gate#
297c478bd9Sstevel@tonic-gate
306927f468Sdp. /lib/svc/share/smf_include.sh
316927f468Sdp. /lib/svc/share/net_include.sh
326927f468Sdp
337c478bd9Sstevel@tonic-gate#
34f4b3ec61Sdh155122# In a shared-IP zone we need this service to be up, but all of the work
357c478bd9Sstevel@tonic-gate# it tries to do is irrelevant (and will actually lead to the service
367c478bd9Sstevel@tonic-gate# failing if we try to do it), so just bail out.
37f4b3ec61Sdh155122# In the global zone and exclusive-IP zones we proceed.
387c478bd9Sstevel@tonic-gate#
39f4b3ec61Sdh155122smf_configure_ip || exit $SMF_EXIT_OK
407c478bd9Sstevel@tonic-gate
417c478bd9Sstevel@tonic-gate# Make sure that the libraries essential to this stage of booting can be found.
427c478bd9Sstevel@tonic-gateLD_LIBRARY_PATH=/lib; export LD_LIBRARY_PATH
437c478bd9Sstevel@tonic-gate
447c478bd9Sstevel@tonic-gatesmf_netstrategy
457c478bd9Sstevel@tonic-gate
46f4b3ec61Sdh155122if smf_is_globalzone; then
47d62bc4baSyz147064	net_reconfigure || exit $SMF_EXIT_ERR_CONFIG
48d62bc4baSyz147064
49d62bc4baSyz147064	#
50d62bc4baSyz147064	# Upgrade handling. The upgrade file consists of a series of dladm(1M)
51d62bc4baSyz147064	# commands. Note that after we are done, we cannot rename the upgrade
52d62bc4baSyz147064	# script file as the file system is still read-only at this point.
53d62bc4baSyz147064	# Defer this to the manifest-import service.
54d62bc4baSyz147064	#
55d62bc4baSyz147064	upgrade_script=/var/svc/profile/upgrade_datalink
56d62bc4baSyz147064	if [ -f "${upgrade_script}" ]; then
57d62bc4baSyz147064		. "${upgrade_script}"
58d62bc4baSyz147064	fi
59d62bc4baSyz147064
607c478bd9Sstevel@tonic-gate	#
61*b509e89bSRishi Srivatsavai	# Bring up simnets, link aggregations and initialize security objects.
620ba2cbe9Sxc151355	# Note that link property initialization is deferred until after
630ba2cbe9Sxc151355	# IP interfaces are plumbed to ensure that the links will not
64*b509e89bSRishi Srivatsavai	# be unloaded (and the property settings lost). We should bring
65*b509e89bSRishi Srivatsavai	# up simnets prior to VLANs/Aggrs to enable creation of VLANs/Aggrs
66*b509e89bSRishi Srivatsavai	# over simnets.
67210db224Sericheng	#
68*b509e89bSRishi Srivatsavai	/sbin/dladm up-simnet
69210db224Sericheng	/sbin/dladm up-aggr
70d62bc4baSyz147064	/sbin/dladm up-vlan
710ba2cbe9Sxc151355	/sbin/dladm init-secobj
72da14cebeSEric Cheng	#
73da14cebeSEric Cheng	# Bring up VNICs
74da14cebeSEric Cheng	#
75da14cebeSEric Cheng	/sbin/dladm up-vnic
76da14cebeSEric Cheng	#
77da14cebeSEric Cheng	# Create flows via flowadm.
78da14cebeSEric Cheng	#
79da14cebeSEric Cheng	/sbin/flowadm init-flow
80f4b3ec61Sdh155122fi
81210db224Sericheng
82210db224Sericheng#
837c478bd9Sstevel@tonic-gate# If the system was net booted by DHCP, hand DHCP management off to the
847c478bd9Sstevel@tonic-gate# DHCP agent (ifconfig communicates to the DHCP agent through the
857c478bd9Sstevel@tonic-gate# loopback interface).
867c478bd9Sstevel@tonic-gate#
877c478bd9Sstevel@tonic-gateif [ -n "$_INIT_NET_IF" -a "$_INIT_NET_STRATEGY" = "dhcp" ]; then
887c478bd9Sstevel@tonic-gate	/sbin/dhcpagent -a
897c478bd9Sstevel@tonic-gatefi
907c478bd9Sstevel@tonic-gate
917c478bd9Sstevel@tonic-gate#
927c478bd9Sstevel@tonic-gate# The network initialization is done early to support diskless and
937c478bd9Sstevel@tonic-gate# dataless configurations.  For IPv4 interfaces that were configured by
947c478bd9Sstevel@tonic-gate# the kernel (e.g.  those on diskless machines) and not configured by
957c478bd9Sstevel@tonic-gate# DHCP, reset the netmask using the local "/etc/netmasks" file if one
967c478bd9Sstevel@tonic-gate# exists, and then reset the broadcast address based on the netmask.
977c478bd9Sstevel@tonic-gate#
987c478bd9Sstevel@tonic-gate/sbin/ifconfig -auD4 netmask + broadcast +
997c478bd9Sstevel@tonic-gate
1007c478bd9Sstevel@tonic-gate#
1017c478bd9Sstevel@tonic-gate# All the IPv4 and IPv6 interfaces are plumbed before doing any
1027c478bd9Sstevel@tonic-gate# interface configuration.  This prevents errors from plumb failures
1037c478bd9Sstevel@tonic-gate# getting mixed in with the configured interface lists that the script
1047c478bd9Sstevel@tonic-gate# outputs.
1057c478bd9Sstevel@tonic-gate#
1067c478bd9Sstevel@tonic-gate
1077c478bd9Sstevel@tonic-gate#
1087c478bd9Sstevel@tonic-gate# Get the list of IPv4 interfaces to configure by breaking
1097c478bd9Sstevel@tonic-gate# /etc/hostname.* into separate args by using "." as a shell separator
1107c478bd9Sstevel@tonic-gate# character.
1117c478bd9Sstevel@tonic-gate#
1127c478bd9Sstevel@tonic-gateinterface_names="`echo /etc/hostname.*[0-9] 2>/dev/null`"
1137c478bd9Sstevel@tonic-gateif [ "$interface_names" != "/etc/hostname.*[0-9]" ]; then
1147c478bd9Sstevel@tonic-gate	ORIGIFS="$IFS"
1157c478bd9Sstevel@tonic-gate	IFS="$IFS."
1167c478bd9Sstevel@tonic-gate	set -- $interface_names
1177c478bd9Sstevel@tonic-gate	IFS="$ORIGIFS"
1187c478bd9Sstevel@tonic-gate	while [ $# -ge 2 ]; do
1197c478bd9Sstevel@tonic-gate		shift
120e11c3f44Smeem		intf_name=$1
121e11c3f44Smeem		while [ $# -gt 1 -a "$2" != "/etc/hostname" ]; do
122e11c3f44Smeem			intf_name="$intf_name.$2"
1237c478bd9Sstevel@tonic-gate			shift
1247c478bd9Sstevel@tonic-gate		done
1257c478bd9Sstevel@tonic-gate		shift
126e11c3f44Smeem
127e11c3f44Smeem	        read one rest < /etc/hostname.$intf_name
128e11c3f44Smeem		if [ "$one" = ipmp ]; then
129e11c3f44Smeem			ipmp_list="$ipmp_list $intf_name"
130e11c3f44Smeem		else
131e11c3f44Smeem			inet_list="$inet_list $intf_name"
1327c478bd9Sstevel@tonic-gate		fi
1337c478bd9Sstevel@tonic-gate	done
1347c478bd9Sstevel@tonic-gatefi
1357c478bd9Sstevel@tonic-gate
1367c478bd9Sstevel@tonic-gate#
1377c478bd9Sstevel@tonic-gate# Get the list of IPv6 interfaces to configure by breaking
1387c478bd9Sstevel@tonic-gate# /etc/hostname6.* into separate args by using "." as a shell separator
1397c478bd9Sstevel@tonic-gate# character.
1407c478bd9Sstevel@tonic-gate#
1417c478bd9Sstevel@tonic-gateinterface_names="`echo /etc/hostname6.*[0-9] 2>/dev/null`"
1427c478bd9Sstevel@tonic-gateif [ "$interface_names" != "/etc/hostname6.*[0-9]" ]; then
1437c478bd9Sstevel@tonic-gate	ORIGIFS="$IFS"
1447c478bd9Sstevel@tonic-gate	IFS="$IFS."
1457c478bd9Sstevel@tonic-gate	set -- $interface_names
1467c478bd9Sstevel@tonic-gate	IFS="$ORIGIFS"
1477c478bd9Sstevel@tonic-gate	while [ $# -ge 2 ]; do
1487c478bd9Sstevel@tonic-gate		shift
149e11c3f44Smeem		intf_name=$1
150e11c3f44Smeem		while [ $# -gt 1 -a "$2" != "/etc/hostname6" ]; do
151e11c3f44Smeem			intf_name="$intf_name.$2"
1527c478bd9Sstevel@tonic-gate			shift
1537c478bd9Sstevel@tonic-gate		done
1547c478bd9Sstevel@tonic-gate		shift
155e11c3f44Smeem
156e11c3f44Smeem	        read one rest < /etc/hostname6.$intf_name
157e11c3f44Smeem		if [ "$one" = ipmp ]; then
158e11c3f44Smeem			ipmp6_list="$ipmp6_list $intf_name"
159e11c3f44Smeem		else
160e11c3f44Smeem			inet6_list="$inet6_list $intf_name"
1617c478bd9Sstevel@tonic-gate		fi
1627c478bd9Sstevel@tonic-gate	done
1637c478bd9Sstevel@tonic-gatefi
1647c478bd9Sstevel@tonic-gate
165e11c3f44Smeem#
166e11c3f44Smeem# Create all of the IPv4 IPMP interfaces.
167e11c3f44Smeem#
168e11c3f44Smeemif [ -n "$ipmp_list" ]; then
169e11c3f44Smeem	set -- $ipmp_list
170e11c3f44Smeem	while [ $# -gt 0 ]; do
171e11c3f44Smeem	    	if /sbin/ifconfig $1 ipmp; then
172e11c3f44Smeem			ipmp_created="$ipmp_created $1"
173e11c3f44Smeem		else
174e11c3f44Smeem			ipmp_failed="$ipmp_failed $1"
175e11c3f44Smeem		fi
176e11c3f44Smeem		shift
177e11c3f44Smeem	done
178e11c3f44Smeem	[ -n "$ipmp_failed" ] && warn_failed_ifs "create IPv4 IPMP" \
179e11c3f44Smeem	    "$ipmp_failed"
180e11c3f44Smeemfi
1817c478bd9Sstevel@tonic-gate
1827c478bd9Sstevel@tonic-gate#
1837c478bd9Sstevel@tonic-gate# Step through the IPv4 interface list and try to plumb every interface.
1847c478bd9Sstevel@tonic-gate# Generate list of plumbed and failed IPv4 interfaces.
1857c478bd9Sstevel@tonic-gate#
1867c478bd9Sstevel@tonic-gateif [ -n "$inet_list" ]; then
1877c478bd9Sstevel@tonic-gate	set -- $inet_list
1887c478bd9Sstevel@tonic-gate	while [ $# -gt 0 ]; do
1897c478bd9Sstevel@tonic-gate		/sbin/ifconfig $1 plumb
1907c478bd9Sstevel@tonic-gate		if /sbin/ifconfig $1 inet >/dev/null 2>&1; then
1917c478bd9Sstevel@tonic-gate			inet_plumbed="$inet_plumbed $1"
1927c478bd9Sstevel@tonic-gate		else
1937c478bd9Sstevel@tonic-gate			inet_failed="$inet_failed $1"
1947c478bd9Sstevel@tonic-gate		fi
1957c478bd9Sstevel@tonic-gate		shift
1967c478bd9Sstevel@tonic-gate	done
197e11c3f44Smeem	[ -n "$inet_failed" ] && warn_failed_ifs "plumb IPv4" "$inet_failed"
1987c478bd9Sstevel@tonic-gatefi
1997c478bd9Sstevel@tonic-gate
200516fc7f3Shx147065# Run autoconf to connect to a WLAN if the interface is a wireless one
201516fc7f3Shx147065if [ -x /sbin/wificonfig -a -n "$inet_plumbed" ]; then
202516fc7f3Shx147065	set -- $inet_plumbed
203516fc7f3Shx147065	while [ $# -gt 0 ]; do
204516fc7f3Shx147065			if [ -r /dev/wifi/$1 ]; then
205516fc7f3Shx147065				/sbin/wificonfig -i $1 startconf >/dev/null
206516fc7f3Shx147065			fi
207516fc7f3Shx147065		shift
208516fc7f3Shx147065	done
209516fc7f3Shx147065fi
210516fc7f3Shx147065
2117c478bd9Sstevel@tonic-gate#
2127c478bd9Sstevel@tonic-gate# Step through the IPv6 interface list and plumb every interface.
2137c478bd9Sstevel@tonic-gate# Generate list of plumbed and failed IPv6 interfaces.  Each plumbed
2147c478bd9Sstevel@tonic-gate# interface will be brought up later, after processing any contents of
2157c478bd9Sstevel@tonic-gate# the /etc/hostname6.* file.
2167c478bd9Sstevel@tonic-gate#
2177c478bd9Sstevel@tonic-gateif [ -n "$inet6_list" ]; then
2187c478bd9Sstevel@tonic-gate	set -- $inet6_list
2197c478bd9Sstevel@tonic-gate	while [ $# -gt 0 ]; do
2207c478bd9Sstevel@tonic-gate		/sbin/ifconfig $1 inet6 plumb
2217c478bd9Sstevel@tonic-gate		if /sbin/ifconfig $1 inet6 >/dev/null 2>&1; then
2227c478bd9Sstevel@tonic-gate			inet6_plumbed="$inet6_plumbed $1"
2237c478bd9Sstevel@tonic-gate		else
2247c478bd9Sstevel@tonic-gate			inet6_failed="$inet6_failed $1"
2257c478bd9Sstevel@tonic-gate		fi
2267c478bd9Sstevel@tonic-gate		shift
2277c478bd9Sstevel@tonic-gate	done
228e11c3f44Smeem	[ -n "$inet6_failed" ] && warn_failed_ifs "plumb IPv6" "$inet6_failed"
229e11c3f44Smeemfi
230e11c3f44Smeem
231e11c3f44Smeem#
232e11c3f44Smeem# Create all of the IPv6 IPMP interfaces.
233e11c3f44Smeem#
234e11c3f44Smeemif [ -n "$ipmp6_list" ]; then
235e11c3f44Smeem	set -- $ipmp6_list
236e11c3f44Smeem	while [ $# -gt 0 ]; do
237e11c3f44Smeem	    	if /sbin/ifconfig $1 inet6 ipmp; then
238e11c3f44Smeem			ipmp6_created="$ipmp6_created $1"
239e11c3f44Smeem		else
240e11c3f44Smeem			ipmp6_failed="$ipmp6_failed $1"
241e11c3f44Smeem 		fi
242e11c3f44Smeem		shift
243e11c3f44Smeem	done
244e11c3f44Smeem	[ -n "$ipmp6_failed" ] && warn_failed_ifs "create IPv6 IPMP" \
245e11c3f44Smeem	    "$ipmp6_failed"
2467c478bd9Sstevel@tonic-gatefi
2477c478bd9Sstevel@tonic-gate
248f4b3ec61Sdh155122if smf_is_globalzone; then
2497c478bd9Sstevel@tonic-gate	#
25030890389Sartem	# Wifi drivers use special property interfaces that are not supported
25130890389Sartem	# by the existing property persistence mechanism, so if a wifi driver
25230890389Sartem	# unloads and then is subsequently reloaded, associated links' properties
25330890389Sartem	# will not be restored.  For now, wait until after interfaces have been
254f4b3ec61Sdh155122	# plumbed (above) to initialize link properties.
2550ba2cbe9Sxc151355	#
25630890389Sartem	/sbin/dladm init-linkprop -w
257f4b3ec61Sdh155122fi
2580ba2cbe9Sxc151355
2590ba2cbe9Sxc151355#
260e11c3f44Smeem# Process the /etc/hostname[6].* files for IPMP interfaces.  Processing these
261e11c3f44Smeem# before non-IPMP interfaces avoids accidental implicit IPMP group creation.
2627c478bd9Sstevel@tonic-gate#
263e11c3f44Smeem[ -n "$ipmp_created" ] && if_configure inet "IPMP" $ipmp_created
264e11c3f44Smeem[ -n "$ipmp6_created" ] && if_configure inet6 "IPMP" $ipmp6_created
2657c478bd9Sstevel@tonic-gate
2667c478bd9Sstevel@tonic-gate#
267e11c3f44Smeem# Process the /etc/hostname[6].* files for non-IPMP interfaces.
2687c478bd9Sstevel@tonic-gate#
269e11c3f44Smeem[ -n "$inet_plumbed" ] && if_configure inet "" $inet_plumbed
270e11c3f44Smeem[ -n "$inet6_plumbed" ] && if_configure inet6 "" $inet6_plumbed
271e11c3f44Smeem
272e11c3f44Smeem#
273e11c3f44Smeem# For the IPv4 and IPv6 interfaces that failed to plumb, find (or create)
274e11c3f44Smeem# IPMP meta-interfaces to host their data addresses.
275e11c3f44Smeem#
276e11c3f44Smeem[ -n "$inet_failed" ] && move_addresses inet
277e11c3f44Smeem[ -n "$inet6_failed" ] && move_addresses inet6
2787c478bd9Sstevel@tonic-gate
2797c478bd9Sstevel@tonic-gate# Run DHCP if requested. Skip boot-configured interface.
2807c478bd9Sstevel@tonic-gateinterface_names="`echo /etc/dhcp.*[0-9] 2>/dev/null`"
2817c478bd9Sstevel@tonic-gateif [ "$interface_names" != '/etc/dhcp.*[0-9]' ]; then
2827c478bd9Sstevel@tonic-gate	#
2837c478bd9Sstevel@tonic-gate	# First find the primary interface. Default to the first
2847c478bd9Sstevel@tonic-gate	# interface if not specified. First primary interface found
2857c478bd9Sstevel@tonic-gate	# "wins". Use care not to "reconfigure" a net-booted interface
2867c478bd9Sstevel@tonic-gate	# configured using DHCP. Run through the list of interfaces
2877c478bd9Sstevel@tonic-gate	# again, this time trying DHCP.
2887c478bd9Sstevel@tonic-gate	#
2897c478bd9Sstevel@tonic-gate	i4d_fail=
2907c478bd9Sstevel@tonic-gate	firstif=
2917c478bd9Sstevel@tonic-gate	primary=
2927c478bd9Sstevel@tonic-gate	ORIGIFS="$IFS"
2937c478bd9Sstevel@tonic-gate	IFS="${IFS}."
2947c478bd9Sstevel@tonic-gate	set -- $interface_names
2957c478bd9Sstevel@tonic-gate
2967c478bd9Sstevel@tonic-gate	while [ $# -ge 2 ]; do
2977c478bd9Sstevel@tonic-gate		shift
2987c478bd9Sstevel@tonic-gate		[ -z "$firstif" ] && firstif=$1
2997c478bd9Sstevel@tonic-gate
3007c478bd9Sstevel@tonic-gate		for i in `shcat /etc/dhcp\.$1`; do
3017c478bd9Sstevel@tonic-gate			if [ "$i" = primary ]; then
3027c478bd9Sstevel@tonic-gate				primary=$1
3037c478bd9Sstevel@tonic-gate				break
3047c478bd9Sstevel@tonic-gate			fi
3057c478bd9Sstevel@tonic-gate		done
3067c478bd9Sstevel@tonic-gate
3077c478bd9Sstevel@tonic-gate		[ -n "$primary" ] && break
3087c478bd9Sstevel@tonic-gate		shift
3097c478bd9Sstevel@tonic-gate	done
3107c478bd9Sstevel@tonic-gate
3117c478bd9Sstevel@tonic-gate	[ -z "$primary" ] && primary="$firstif"
3127c478bd9Sstevel@tonic-gate	cmdline=`shcat /etc/dhcp\.${primary}`
3137c478bd9Sstevel@tonic-gate
3147c478bd9Sstevel@tonic-gate	if [ "$_INIT_NET_IF" != "$primary" ]; then
3157c478bd9Sstevel@tonic-gate		echo "starting DHCP on primary interface $primary"
3167c478bd9Sstevel@tonic-gate		/sbin/ifconfig $primary auto-dhcp primary $cmdline
3177c478bd9Sstevel@tonic-gate		# Exit code 4 means ifconfig timed out waiting for dhcpagent
3187c478bd9Sstevel@tonic-gate		[ $? != 0 ] && [ $? != 4 ] && i4d_fail="$i4d_fail $primary"
3197c478bd9Sstevel@tonic-gate	fi
3207c478bd9Sstevel@tonic-gate
3217c478bd9Sstevel@tonic-gate	set -- $interface_names
3227c478bd9Sstevel@tonic-gate
3237c478bd9Sstevel@tonic-gate	while [ $# -ge 2 ]; do
3247c478bd9Sstevel@tonic-gate		shift
3257c478bd9Sstevel@tonic-gate		cmdline=`shcat /etc/dhcp\.$1`
3267c478bd9Sstevel@tonic-gate		if [ "$1" != "$primary" -a \
3277c478bd9Sstevel@tonic-gate			"$1" != "$_INIT_NET_IF"  ]; then
3287c478bd9Sstevel@tonic-gate			echo "starting DHCP on interface $1"
3297c478bd9Sstevel@tonic-gate			/sbin/ifconfig $1 dhcp start wait 0 $cmdline
3307c478bd9Sstevel@tonic-gate			# Exit code can't be timeout when wait is 0
3317c478bd9Sstevel@tonic-gate			[ $? != 0 ] && i4d_fail="$i4d_fail $1"
3327c478bd9Sstevel@tonic-gate		fi
3337c478bd9Sstevel@tonic-gate		shift
3347c478bd9Sstevel@tonic-gate	done
3357c478bd9Sstevel@tonic-gate	IFS="$ORIGIFS"
3367c478bd9Sstevel@tonic-gate	unset ORIGIFS
337e11c3f44Smeem	[ -n "$i4d_fail" ] && warn_failed_ifs "configure IPv4 DHCP" "$i4d_fail"
3387c478bd9Sstevel@tonic-gatefi
3397c478bd9Sstevel@tonic-gate
3400659b2b8Sse146197# In order to avoid bringing up the interfaces that have
3410659b2b8Sse146197# intentionally been left down, perform RARP only if the system
3420659b2b8Sse146197# has no configured hostname in /etc/nodename
3430659b2b8Sse146197hostname="`shcat /etc/nodename 2>/dev/null`"
3440659b2b8Sse146197if [ "$_INIT_NET_STRATEGY" = "rarp" -o -z "$hostname" ]; then
3457c478bd9Sstevel@tonic-gate	/sbin/ifconfig -adD4 auto-revarp netmask + broadcast + up
3460659b2b8Sse146197fi
3477c478bd9Sstevel@tonic-gate
3487c478bd9Sstevel@tonic-gate#
3497c478bd9Sstevel@tonic-gate# If the /etc/defaultrouter file exists, process it now so that the next
3507c478bd9Sstevel@tonic-gate# stage of booting will have access to NFS.
3517c478bd9Sstevel@tonic-gate#
3527c478bd9Sstevel@tonic-gateif [ -f /etc/defaultrouter ]; then
3537c478bd9Sstevel@tonic-gate	while read router rubbish; do
3547c478bd9Sstevel@tonic-gate		case "$router" in
3557c478bd9Sstevel@tonic-gate			'#'* | '') ;;	#  Ignore comments, empty lines
3567c478bd9Sstevel@tonic-gate			*)	/sbin/route -n add default -gateway $router ;;
3577c478bd9Sstevel@tonic-gate		esac
3587c478bd9Sstevel@tonic-gate	done </etc/defaultrouter
3597c478bd9Sstevel@tonic-gatefi
3607c478bd9Sstevel@tonic-gate
3617c478bd9Sstevel@tonic-gate#
362843e1988Sjohnlev# If we get here and were not asked to plumb any IPv4 interfaces, look
363843e1988Sjohnlev# for boot properties that direct us.
364843e1988Sjohnlev#
365843e1988Sjohnlev# - The "network-interface" property is required and indicates the
366843e1988Sjohnlev#   interface name.
367843e1988Sjohnlev# - The "xpv-hcp" property, if present, is used by the hypervisor
368843e1988Sjohnlev#   tools to indicate how the specified interface should be configured.
369843e1988Sjohnlev#   Permitted values are "dhcp" and "off", where "off" indicates static
370843e1988Sjohnlev#   IP configuration.
371843e1988Sjohnlev#
372843e1988Sjohnlev# In the case where "xpv-hcp" is set to "dhcp", no further properties
373843e1988Sjohnlev# are required or examined.
374843e1988Sjohnlev#
375843e1988Sjohnlev# In the case where "xpv-hcp" is not present or set to "off", the
376843e1988Sjohnlev# "host-ip" and "subnet-mask" properties are used to configure
377843e1988Sjohnlev# the specified interface.  The "router-ip" property, if present,
378843e1988Sjohnlev# is used to add a default route.
379843e1988Sjohnlev#
380843e1988Sjohnlevnic="`/sbin/devprop network-interface`"
381843e1988Sjohnlevif smf_is_globalzone && [ -z "$inet_list" ] && [ -n "$nic" ]; then
382843e1988Sjohnlev	hcp="`/sbin/devprop xpv-hcp`"
383843e1988Sjohnlev	case "$hcp" in
384843e1988Sjohnlev	"dhcp")
385843e1988Sjohnlev		/sbin/ifconfig $nic plumb 2>/dev/null
386843e1988Sjohnlev		[ -n "`/sbin/ifconfig $nic 2>/dev/null`" ] && (
387843e1988Sjohnlev			# The interface is successfully plumbed, so
388843e1988Sjohnlev			# modify "inet_list" to force the exit code
389843e1988Sjohnlev			# checks to work.
390843e1988Sjohnlev			inet_list=$nic;
391843e1988Sjohnlev			# Given that this is the only IPv4 interface,
392843e1988Sjohnlev			# we assert that it is primary.
393843e1988Sjohnlev			echo "starting DHCP on primary interface $primary";
394843e1988Sjohnlev			/sbin/ifconfig $nic auto-dhcp primary;
395843e1988Sjohnlev			# Exit code 4 means ifconfig timed out waiting
396843e1988Sjohnlev			# for dhcpagent
397843e1988Sjohnlev			[ $? != 0 ] && [ $? != 4 ] && \
398843e1988Sjohnlev			    i4d_fail="$i4d_fail $nic";
399843e1988Sjohnlev		)
400843e1988Sjohnlev		;;
401843e1988Sjohnlev
402843e1988Sjohnlev	"off"|"")
403843e1988Sjohnlev		/sbin/devprop host-ip subnet-mask router-ip | (
404843e1988Sjohnlev			read ip;
405843e1988Sjohnlev			read mask;
406843e1988Sjohnlev			read router;
407843e1988Sjohnlev			[ -n "$ip" ] && [ -n "$mask" ] && \
408843e1988Sjohnlev				/sbin/ifconfig $nic plumb 2>/dev/null
409843e1988Sjohnlev			[ -n "`/sbin/ifconfig $nic 2>/dev/null`" ] && (
410843e1988Sjohnlev				# The interface is successfully
411843e1988Sjohnlev				# plumbed, so modify "inet_list" to
412843e1988Sjohnlev				# force the exit code checks to work.
413843e1988Sjohnlev				inet_list=$nic;
414843e1988Sjohnlev				/sbin/ifconfig $nic  inet $ip \
415843e1988Sjohnlev				    netmask $mask broadcast + up 2>/dev/null;
416843e1988Sjohnlev				[ -n "$router" ] && route add \
417843e1988Sjohnlev				    default $router 2>/dev/null;
418843e1988Sjohnlev			)
419843e1988Sjohnlev		)
420843e1988Sjohnlev		;;
421843e1988Sjohnlev	esac
422843e1988Sjohnlevfi
423843e1988Sjohnlev
424843e1988Sjohnlev#
4257c478bd9Sstevel@tonic-gate# We tell smf this service is online if any of the following is true:
4267c478bd9Sstevel@tonic-gate# - no interfaces were configured for plumbing and no DHCP failures
4277c478bd9Sstevel@tonic-gate# - any non-loopback IPv4 interfaces are up and have a non-zero address
4287c478bd9Sstevel@tonic-gate# - there are any DHCP interfaces started
4297c478bd9Sstevel@tonic-gate# - any non-loopback IPv6 interfaces are up
4307c478bd9Sstevel@tonic-gate#
4317c478bd9Sstevel@tonic-gate# If we weren't asked to configure any interfaces, exit
4327c478bd9Sstevel@tonic-gateif [ -z "$inet_list" ] && [ -z "$inet6_list" ]; then
4337c478bd9Sstevel@tonic-gate	# Config error if DHCP was attempted without plumbed interfaces
4347c478bd9Sstevel@tonic-gate	[ -n "$i4d_fail" ] && exit $SMF_EXIT_ERR_CONFIG
4357c478bd9Sstevel@tonic-gate	exit $SMF_EXIT_OK
4367c478bd9Sstevel@tonic-gatefi
4377c478bd9Sstevel@tonic-gate
4387c478bd9Sstevel@tonic-gate# Any non-loopback IPv4 interfaces with usable addresses up?
4397c478bd9Sstevel@tonic-gateif [ -n "`/sbin/ifconfig -a4u`" ]; then
4407c478bd9Sstevel@tonic-gate    	/sbin/ifconfig -a4u | while read intf addr rest; do
4417c478bd9Sstevel@tonic-gate		[ $intf = inet ] && [ $addr != 127.0.0.1 ] &&
442843e1988Sjohnlev		[ $addr != 0.0.0.0 ] && exit $SMF_EXIT_OK
4437c478bd9Sstevel@tonic-gate	done && exit $SMF_EXIT_OK
4447c478bd9Sstevel@tonic-gatefi
4457c478bd9Sstevel@tonic-gate
4467c478bd9Sstevel@tonic-gate# Any DHCP interfaces started?
4477c478bd9Sstevel@tonic-gate[ -n "`/sbin/ifconfig -a4 dhcp status 2>/dev/null`" ] && exit $SMF_EXIT_OK
4487c478bd9Sstevel@tonic-gate
4497c478bd9Sstevel@tonic-gate# Any non-loopback IPv6 interfaces up?
4507c478bd9Sstevel@tonic-gateif [ -n "`/sbin/ifconfig -au6`" ]; then
4517c478bd9Sstevel@tonic-gate	/sbin/ifconfig -au6 | while read intf addr rest; do
452843e1988Sjohnlev		[ $intf = inet6 ] && [ $addr != ::1/128 ] && exit $SMF_EXIT_OK
4537c478bd9Sstevel@tonic-gate	done && exit $SMF_EXIT_OK
4547c478bd9Sstevel@tonic-gatefi
4557c478bd9Sstevel@tonic-gate
4567c478bd9Sstevel@tonic-gate# This service was supposed to configure something yet didn't.  Exit
4577c478bd9Sstevel@tonic-gate# with config error.
4587c478bd9Sstevel@tonic-gateexit $SMF_EXIT_ERR_CONFIG
459